Attribute VB_Name = "Module1"

Option Explicit

Private Declare Function CreateToolhelpSnapshot Lib "kernel32" _
    Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, _
    ByVal lProcessID As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" _
    (ByVal hSnapShot As Long, uProcess As PROC_INFO) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" _
    (ByVal hSnapShot As Long, uProcess As PROC_INFO) As Long
Private Declare Sub CloseHandle Lib "kernel32" (ByVal hPass As Long)

Private Type PROC_INFO
  dwordSize As Long
  Usage As Long
  ProcessID As Long
  DefaultHeapID As Long
  ModuleID As Long
  Threads As Long
  ParentProcessID As Long
  ClassBase As Long
  dwordFlags As Long
  FileSize As String * 260
End Type

Dim i As Long, someInt As Long, var As Long, x(1 To 3) As Long

Function ProcessesExists(ProcessName As String) As Long
  Dim Count As Long, LH_SS As Long, CurProcess As PROC_INFO, RetVal As Long
  Count = 0
  LH_SS = CreateToolhelpSnapshot(2, 0)
  CurProcess.dwordSize = Len(CurProcess)
  RetVal = ProcessFirst(LH_SS, CurProcess)
  Do While RetVal
    If InStr(1, CurProcess.FileSize, ProcessName) <> 0 Then Count = Count + 1
    RetVal = ProcessNext(LH_SS, CurProcess)
  Loop
  CloseHandle LH_SS
  ProcessesExists = Count
End Function

Private Sub FindSol()
  Open "MIT.lp" For Output Access Write As #1
  Print #1, "maximize"
  Print #1, "f: x" & CStr(var)
  Print #1, "subject to"
  Print #1, "x1 + x2 + x3 + x4 = 20"
  Print #1, "x2 + x3 + x4 + x5 = 21"
  Print #1, "x3 + x4 + x5 + x6 = 17"
  Print #1, "x4 + x5 + x6 + x7 = 18"
  Print #1, "x5 + x6 + x7 + x8 = 17"
  Print #1, "x6 + x7 + x8 + x9 = 11"
'  Print #1, "x1 <= 255"
'  Print #1, "x2 <= 255"
'  Print #1, "x3 <= 255"
'  Print #1, "x4 <= 255"
'  Print #1, "x5 <= 255"
'  Print #1, "x6 <= 255"
'  Print #1, "x7 <= 255"
'  Print #1, "x8 <= 255"
'  Print #1, "x9 <= 255"
  Print #1, "x1 <= 9"
  Print #1, "x2 <= 9"
  Print #1, "x3 <= 9"
  Print #1, "x4 <= 9"
  Print #1, "x5 <= 9"
  Print #1, "x6 <= 9"
  Print #1, "x7 <= 9"
  Print #1, "x8 <= 9"
  Print #1, "x9 <= 9"
  For i = 1 To var - 1
    Print #1, "x" & CStr(i) & " = " & CStr(x(i))
  Next i
  Print #1, "integer"
  Print #1, "x1"
  Print #1, "x2"
  Print #1, "x3"
  Print #1, "x4"
  Print #1, "x5"
  Print #1, "x6"
  Print #1, "x7"
  Print #1, "x8"
  Print #1, "x9"
  Print #1, "end"
  Close #1
  Shell "glpsol --cpxlp MIT.lp -w 1.txt", vbHide
  Do While ProcessesExists("glpsol.exe") >= 1
    DoEvents
  Loop
End Sub

Private Sub OutputComb()
  Dim xout(1 To 9) As Long
  Input #1, someInt, someInt, someInt, someInt, someInt, someInt
  For i = 1 To 9
    Input #1, xout(i)
  Next i
  Print #2, xout(1); xout(2); xout(3); xout(4); _
      xout(5); xout(6); xout(7); xout(8); xout(9)
End Sub

Function LowerVar() As Long
  Do While x(var - 1) = 0
    var = var - 1
    If var = 1 Then
      LowerVar = 1
      Exit Function
    End If
  Loop
  x(var - 1) = x(var - 1) - 1
  LowerVar = 0
End Function

Private Sub Main()
  Dim max As Long, status As Long
  ChDir "C:\glpk-4.36\w32\1\"
  var = 1
  Open "2.txt" For Output Access Write As #2
  Do While True
    FindSol
    Open "1.txt" For Input Access Read As #1
    Input #1, someInt, someInt
    Input #1, status
    If status = 1 Then
      If LowerVar() = 1 Then
        Exit Do
      End If
    ElseIf status = 5 Then
      Input #1, max
      If var < 4 Then
        var = var + 1
        x(var - 1) = max
      Else
        OutputComb
        If LowerVar() = 1 Then
          Exit Do
        End If
      End If
    End If
    Close #1
  Loop
  Close #2
  MsgBox "Ready!"
End Sub
